#ifndef SLSAPIEX_H
#define SLSAPIEX_H

#include "lictype.h"

#ifdef __cplusplus 
extern "C"
{
#endif

//return code from SLS_GenerateKey
#define SLSKEY_SUCCESS				0
#define SLSKEY_ERROR				1
#define SLSKEY_E_BAD_PRODUCT_ID		2
#define SLSKEY_E_BAD_REFERENCE		3
#define SLSKEY_E_BAD_PID_REF		4	//Reference code does not match product ID
#define SLSKEY_E_BAD_LICENCE_TYPE	5
#define SLSKEY_E_BAD_LICENCE_DATE	6
#define SLSKEY_E_BAD_SECRET_SIZE	10
#define SLSKEY_E_BAD_SECRET_1		11
#define SLSKEY_E_BAD_SECRET_2		12
#define SLSKEY_E_BAD_SECRET_3		13
#define SLSKEY_E_BAD_SECRET_4		14
#define SLSKEY_E_BAD_TERMINATE_CODE	15
#define SLSKEY_E_BAD_STATUS_CODE	16


int WINAPI SLS_GenerateLicenceKey(
			LPCSTR		lpszProductID,		//null terminated string
			SLS_SECRET	*ppSecretArray,		//array of secrect codes
			int			nSecretSize,		//should always be 4
			LPCSTR		lpszReferenceCode,	//null terminated string
			SLS_LICENCE *pLicencePolicy,	//licence policy
			LPSTR		lpszLicenceKey);	//point to address to receive licence key, allow 64 bytes. Will be null terminated

//return SLSKEY_ERROR(0) if failed
//return SLSKEY_SUCCESS(1) if succeeded
int WINAPI SLS_VerifyTerminationCode(
			const char *pszProductID,
			const char *pszTerminationCode,
			SLS_LICENCE *plicInfo);

//return SLSKEY_ERROR(0) if failed
//return SLSKEY_SUCCESS(1) if succeeded
int WINAPI SLS_VerifyStatusCode(
			const char *pszProductID,
			const char *pszStatusCode,
			SLS_LICENCE *plicInfo);

int WINAPI SLS_VerifyStatusCodeEx(
			const char *pszProductID,
			const char *pszMachineSignature,
			const char *pszStatusCode,
			SLS_LICENCE *plicInfo);

//return SLSKEY_ERROR(0) if failed
//return SLSKEY_SUCCESS(1) if succeeded
int WINAPI SLS_GenerateRemovePassword(
			LPCSTR		lpszProductID,		//null terminated string
			SLS_SECRET	*ppSecretArray,		//array of secrect codes
			int			nSecretSize,		//should always be 4
			LPCSTR		lpszRemoveReference,//null terminated string
			LPSTR		lpszRemovePassword);//point to address to receive remove password, allow 64 bytes. Will be null terminated

int WINAPI SLS_GetVersionEx(int *pnMajorVersion,int *pnMinorVersion);

#ifdef __cplusplus  
}
#endif

#endif
