Attribute VB_Name = "SlsApi"
' This is a part of the Sheriff System Development Kit.
' Copyright (C) 1997-1998 Acudata Limted.
' All rights reserved.
'
' This source code is only intended as a supplement to the
' Sheriff System Development Kit and related
' electronic documentation provided with the SDK.


'Challenge protocol
Public Const SLS_NO_PROTOCOL = &H0&
Public Const SLS_BASIC_PROTOCOL = &H1&

'state of licence
Public Const SLS_STATE_UNDEFINED = &H0&      'Licence type and contents to be specified
Public Const SLS_STATE_BAD = &H1&            'Licence has being illegally modified
Public Const SLS_STATE_EXPIRED = &H2&        'Licence has expired
Public Const SLS_STATE_EXHAUSTED = &H3&      'Licence units has run out
Public Const SLS_STATE_OK = &H8&             'Licence is valid

'type of licence
Public Const SLS_TYPE_UNDEFINED = &H0&       'Undefined
Public Const SLS_TYPE_UNIT_METER = &H1&      'Unit Metering
Public Const SLS_TYPE_TIME_METER = &H2&      'Time Metering
Public Const SLS_TYPE_EXPIRATION = &H4&      'Expiry Control
Public Const SLS_TYPE_CONCURRENCY = &H8&     'Concurrency Control
Public Const SLS_TYPE_UNLIMITED = &H10&      'Unlimited/Unrestricted
Public Const SLS_TYPE_LIFETIME_KEY = &H100&  'Lifetime key
Public Const SLS_TYPE_LIFETIME_REF = &H200&  'Lifetime Reference
Public Const SLS_TYPE_UNEXPORTABLE = &H400&  'Unexportable

'Everything is fine
Public Const SLS_SUCCESS = &H0&
'General Error (unknown error)
Public Const SLS_ERROR = &H80041000

'System Error
Public Const SLS_E_SYSTEM_ERROR = &H80041001

'Invalid Product Code
Public Const SLS_E_PRODUCT_CODE = &H80041002
'Invalid Reference Code
Public Const SLS_E_REFERENCE_CODE = &H80041003
'Invalid Machine Code
Public Const SLS_E_MACHINE_CODE = &H80041004
'Invalid System Time
Public Const SLS_E_SYSTEM_TIME = &H80041005
'Not Enough Memory
Public Const SLS_E_OUT_OF_MEMORY = &H80041006
'Not Enough Handle
Public Const SLS_E_OUT_OF_HANDLE = &H80041007
'Illegal Challenge
Public Const SLS_E_CHALLENGE_ILLEGAL = &H80041008
'Unsuported challenge
Public Const SLS_E_CHALLENGE_UNSUPORTED = &H80041009
'Connction Sink ID invalid
Public Const SLS_E_CONNECTION_ID = &H8004100A
'Invalid Queue Number
Public Const SLS_E_QUEUE_NUMBER = &H8004100B
'Queue Too Long
Public Const SLS_E_QUEUE_TOO_LONG = &H8004100C
'Failed To Locate Database Path
Public Const SLS_E_DATABASE_PATH = &H8004100D
'Invalid SuitID
Public Const SLS_E_SUIT_ID = &H8004100E
'Unregistered Suit
Public Const SLS_E_SUIT_UNREGISTERED = &H8004100F
'Invalid Augument passed to function
Public Const SLS_E_AUGUMENT_INVALID = &H80041010
'Invalid Handle
Public Const SLS_E_LICENCE_HANDLE = &H80041011
'Unregistered product/licence
Public Const SLS_E_LICENCE_UNREGISTERED = &H80041012
'Licence Undefined
Public Const SLS_E_LICENCE_UNDEFINED = &H80041013
'Licence (run out of cocurrent users)
Public Const SLS_E_LICENCE_EXCEEDED = &H80041014
'Licence Exhausted (run out of meter units)
Public Const SLS_E_LICENCE_EXHAUSTED = &H80041015
'Licence Expired
Public Const SLS_E_LICENCE_EXPIRED = &H80041016
'Licence Invalid (corrupted, tamped)
Public Const SLS_E_LICENCE_INVALID = &H80041017
'Licence Suspended
Public Const SLS_E_LICENCE_SUSPENDED = &H80041018
'Licence Terminated
Public Const SLS_E_LICENCE_TERMINATED = &H80041019
'Licence Unavaliable
Public Const SLS_E_LICENCE_UNAVAILABLE = &H8004101A
'Licence unit not defined
Public Const SLS_E_UNIT_UNDEFINED = &H8004101B
'Licence unit shortage (units been reserved)
Public Const SLS_E_UNIT_EXCEEDED = &H8004101C
'Index used to enumerate products
Const SLS_E_PRODUCT_INDEX = &H8004101D
'Bad Secret
Public Const SLS_E_BAD_SECRET = &H8004101E
'Bad MAC(Message Authentication Code)
Public Const SLS_E_BAD_MAC = &H8004101F

'Licence File Error(used by Sheriff Light only)
'The file could not be located.
Public Const SLS_E_FILE_NOT_FOUND = &H80041020
'All or part of the path is invalid.
Public Const SLS_E_FILE_BAD_PATH = &H80041021
'The permitted number of open files was exceeded.
Public Const SLS_E_FILE_TOO_MANY = &H80041022
'The file could not be accessed
Public Const SLS_E_FILE_ACCESS_DENIED = &H80041023
'There was an attempt to use an invalid file handle.
Public Const SLS_E_FILE_BAD_HANDLE = &H80041024
'There was an error trying to set the file pointer.
Public Const SLS_E_FILE_BAD_SEEK = &H80041025
'There was a hardware error.
Public Const SLS_E_FILE_HARDIO = &H80041026
'SHARE.EXE was not loaded, or a shared region was locked.
Public Const SLS_E_FILE_SHARING = &H80041027
'There was an attempt to lock a region that was already locked.
Public Const SLS_E_FILE_LOCKING = &H80041028
'The disk is full.
Public Const SLS_E_FILE_DISK_FULL = &H80041029
'The end of file was reached.
Public Const SLS_E_FILE_EOF = &H8004102A
'CRC error
Public Const SLS_E_FILE_BAD_CRC = &H8004102B
'Signature error
Public Const SLS_E_FILE_BAD_SIGNATURE = &H8004102C
'Corruption
Public Const SLS_E_FILE_BAD_DATA = &H8004102D
'Disk Signature error
Public Const SLS_E_DISK_BAD_SIGNATURE = &H8004102E

'Invalid Licence Path
Public Const SLS_E_PATH_INVALID = &H80041030
'Failed to create licecne path
Public Const SLS_E_PATH_CREATE = &H80041031
'Access(Read/Write) Denied
Public Const SLS_E_PATH_ACCESS_DENIED = &H80041032
'Registery operation failure
Public Const SLS_E_REG_FAILURE = &H80041033
'Licence File been tampered
Public Const SLS_E_BAD_LICENCE = &H80041034
'Registry has been tampered
Public Const SLS_E_BAD_REGISTRY = &H80041035
'Machine Signature is wrong
Public Const SLS_E_BAD_MACHINE = &H80041036
'Failed to get machine code
Public Const SLS_E_OP_MACHINE_CODE = &H80041037
'Failed to get machine signature
Public Const SLS_E_OP_MACHINE_SIGN = &H80041038
'Failed to get file signature
Public Const SLS_E_OP_FILE_SIGN = &H80041039
'Failed to get disk signature
Public Const SLS_E_OP_DISK_SIGN = &H8004103A

Public Function SUCCEEDED(hr As Long) As Boolean
    SUCCEEDED = (hr = 0)
End Function

Public Function FAILED(hr As Long) As Boolean
    FAILED = (hr <> 0)
End Function

