Attribute VB_Name = "MainVB"
Public Const PRODUCT_ID = "9758-3050-1918-9292-6466"
Public Const PRODUCT_NAME = "SlsDemo VB version"
Public Const USER_NAME = "SlsDemo VB version"
Public Const LICENCE_PATH = "c:\temp"
Public Const LICENCE_FULL = 1
Public Const LICENCE_DEMO = 2
Public Const LICENCE_EXIT = 3

Public Const RUN_FULL = 1
Public Const RUN_DEMO = 2

Public g_nRunMode As Integer
Public fMainForm As frmMain
Public Sheriff As CSheriff

Sub Main()
    Dim bRet As Boolean
            
    Set fMainForm = New frmMain
    Set Sheriff = New CSheriff
    bRet = Sheriff.Create(PRODUCT_ID, USER_NAME)
        
    Dim varSecrets As Variant
    varSecrets = Array(&H76&, &H3E&, &H6D&, &H36&, &H14&, &H14&, &H6D&, &HB8&, &H1D&, &HCA&, &HF3&, &HD5&, &H34&, &H2D&, &H8&, &HBC&, &H14&, &H31&, &H0&, &HB7&, &H17&, &H0&, &H43&, &HFC&, &HC0&, &H7F&, &H8F&, &HA2&, &H22&, &HD2&, &H1B&, &H62&, &HB3&, &HDE&, &H95&, &H3F&, &HAC&, &H2E&, &H39&, &H6F&, &H45&, &HD5&, &H41&, &H11&, &H43&, &H41&, &H2B&, &H75&, &H9C&, &HB2&, &H67&, &H6E&, &H14&, &H2&, &H79&, &H52&, &H9A&, &H49&, &H97&, &H8B&, &H1C&, &H15&, &H64&, &HB7&, &HBE&, &H6C&, &H7F&, &H18&, &HC3&, &H4E&, &H78&, &H87&)
    Sheriff.SetSecrets (varSecrets)
        
    'check to see is the product is ever licensed
    Dim IsProductLicensed As Boolean
    IsProductLicensed = Sheriff.IsProductLicensed()
    If (IsProductLicensed = False) Then
        'install a 30 day trial licence
        'Register it first
        bRet = Sheriff.Register(PRODUCT_NAME, LICENCE_PATH)
        'now issue a 30 day licence
        If (Sheriff.License(30) = False) Then
            Dim strTitle As String
            strTitle = "Issue trial licence"
            Dim strErrorMsg As String
            strErrorMsg = String$(256, 0)
            bRet = Sheriff.GetLastErrorMessage(strErrorMsg)
            MsgBox strErrorMsg, vbExclamation, strTitle
            End
        End If
    End If
        
    'Check licence
    Dim nState As Integer
    nState = CheckLicence()
    Select Case nState
        Case LICENCE_FULL
        'Run in full mode
            g_nRunMode = RUN_FULL
            fMainForm.Show 1
            bRet = Sheriff.Releases()
        Case LICENCE_DEMO
        'Run in demo mode
            g_nRunMode = RUN_DEMO
            fMainForm.Show 1
        Case LICENCE_EXIT
        'exit
    End Select
      
    Set Sheriff = Nothing
    Set fMainForm = Nothing
    
End Sub

Public Function CheckLicence() As Integer
    Dim bRet As Boolean
    Dim lErr As Long
    
    bRet = Sheriff.Register(PRODUCT_NAME, LICENCE_PATH)
    bRet = Sheriff.Request()
    If (bRet = True) Then
        'Set Options
        bRet = Sheriff.SetOptions(2, 3)
        
        Dim LicenceInfo As SLS_LICENCE_INFO
        lErr = SLS_QueryLicenceInfo(PRODUCT_ID, LicenceInfo)
        CheckLicence = LICENCE_FULL
        Exit Function
    End If
    
    'Licence is not ready yet
    lErr = Sheriff.GetLastError()
    If (lErr = SLS_E_LICENCE_UNREGISTERED) Then
        bRet = Sheriff.Register(PRODUCT_NAME, LICENCE_PATH)
        If (bRet = False) Then
            'error in licence registration
            Dim strTitle As String
            strTitle = "Product Registation"
            Dim strErrorMsg As String
            strErrorMsg = String$(256, 0)
            bRet = Sheriff.GetLastErrorMessage(strErrorMsg)
            MsgBox strErrorMsg, vbExclamation, strTitle
            CheckLicence = LICENCE_EXIT
            Exit Function
        End If
        'Register licence
        frmRegister.Show 1
        CheckLicence = frmRegister.GetRegisterState()
        Exit Function
    End If
    If (lErr = SLS_E_LICENCE_UNDEFINED) Then
    'Licence not defined yet
        frmRegister.Show 1
        CheckLicence = frmRegister.GetRegisterState()
        Exit Function
    End If
    If (lErr = SLS_E_LICENCE_EXPIRED) Then
    'Licence has expired
    'To do,add code here
        Exit Function
    End If
    If (lErr = SLS_E_LICENCE_EXCEEDED) Then
    'Licence concurency run out
    'To do,add code here
        Exit Function
    End If
    'Other error
    strTitle = "SlsDemoVB"
    strErrorMsg = String$(256, 0)
    bRet = Sheriff.GetLastErrorMessage(strErrorMsg)
    MsgBox strErrorMsg, vbExclamation, strTitle
    CheckLicence = LICENCE_EXIT
End Function

